/* Full Color LED Test-Program
   Program By GucciTech - Chojiro Higashiguchi
   Date 2008/06/9
   Program Name 'Fullcolor_V4.C'
   PIC MPU PIC16F876A-i/SP
   LCD = SD1602HULB-XA
   LED = OSTA71A1D-A

   I/O Port PIN
      PORTA-0  LED-Red
      PORTA-1  LED-Green
      PORTA-2  LED-Blue

      PORTB-0  Red-SW
      PORTB-1  Green-SW
      PORTB-2  Blue-SW
      PORTB-3  White-SW
      PORTB-4  Yellow-SW
      
      PORTC-2  LCD RS
      PORTC-3  LCD E
      PORTC-4  LCD DB4
      PORTC-5  LCD DB5
      PORTC-6  LCD DB6
      PORTC-7  LCD DB7
*/

#include "Fullcolor_V4.h"
#include "LCD_function_G1.h"

int   swno;

void main()
{
   setup_adc_ports(NO_ANALOGS);
   setup_adc(ADC_OFF);
   setup_spi(SPI_SS_DISABLED);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);

   port_b_pullups(TRUE);
   LCD_init();

   // TODO: USER CODE!!
   output_a(0b00000000);      // LED ALL OFF
   swno = 0;

   LCD_clear();
   LCD_control(0x80);   /* move to line 1 */
   printf(LCD_display, "Full Color Test"); 
   LCD_control(0xc0);   /* move to line 2 */
   printf(LCD_display, "Message OFF");

   while (TRUE)
   {
      swno = input_b() & 0b00111111;
      if (swno == 0x3f)
         delay_ms(5);
      else
      {
         delay_ms(20);     /* anti-chattering */
         if ((input_b() & 0b00111111) == swno)
         {
            LCD_clear();
            LCD_control(0x80);   /* move to line 1 */
            switch (swno)
            {
               case (0b00011111) :  // 0.off
               {
                  output_a(0b00000000);
                  printf(LCD_display,"0.off");
                  LCD_control(0xc0);                     /* move to line 2 */
                  printf(LCD_display, "Message OFF");
                  break;
               }
               case (0b00111011) :  // 1.blue
               {
                  output_a(0b00000100);
                  printf(LCD_display, "1.blue   ");
                  LCD_control(0xc0);                     /* move to line 2 */
                  printf(LCD_display, "READY Stanby");
                  break;
               }
               case (0b00111110) :  // 2.red
               {
                  output_a(0b00000001);
                  printf(LCD_display, "2.red    ");
                  LCD_control(0xc0);                     /* move to line 2 */
                  printf(LCD_display, "HV-ON Danger!");
                  break;
               }
//         case 4 : output_a(0b00000101); printf(LCD_display, "3.magenta"); break;  // 3.magenta [R+B]
               case (0b00111101) :  // 4.green
               {
                  output_a(0b00000010);
                  printf(LCD_display, "4.green  ");
                  LCD_control(0xc0);                     /* move to line 2 */
                  printf(LCD_display, "HV-OFF Stanby");
                  break;
               }
//         case 5 : output_a(0b00000110); printf(LCD_display, "5.cyan   "); break;  // 5.cyan [G+B]
               case (0b00101111) :  // 6.yellow [R+G]
               {
                  output_a(0b00000011);
                  printf(LCD_display, "6.yellow ");
                  LCD_control(0xc0);                     /* move to line 2 */
                  printf(LCD_display, "ERROR! Warning!");
                  break;
               }
               case (0b00110111) :  // 7.white [R+G+B]
               {
                  output_a(0b00000111);
                  printf(LCD_display, "7.white  ");
                  LCD_control(0xc0);                     /* move to line 2 */
                  printf(LCD_display, "POWER ON Stanby");
                  break;
               }
               default : output_a(0b00000000); break;
            }
            while(TRUE)
            {
               if ((input_b() & 0b00111111) == 0x3f)
               break;
            }
         }
         else
            delay_ms(5);
      }
      swno = 0;
   }
}
